/* eslint-disable new-cap */
const express = require('express');
const formidable = require('formidable');
const path = require('path');
const router = express.Router();
const fs = require('fs');

// Reitti sovelluksen etusivulle
router.get('/', function (req, res, next) {
  // res.render renderöi web-sivun
  res.render('index', { title: 'Express' });
});
// Reitti joka tarjoaa yksinkertaisen REST-api:n
router.get('/restapi1', function (req, res) {
  // res.json tuottaa jsonia
  res.json({
    name: 'J.K Paasikivi',
    job: 'President',
    country: 'Finland',
  });
});

// Reitti upload-sivulle
router.get('/upload', (req, res) => {
  res.render('upload', { title: 'Express' });
});

// Reitti joka ottaa vastaan viewin lomakkelta post-metodilla tulevan tiedoston
// Lomake joka laukaisee tämän reitin suorituksen voisi olla myös esim. Angular-frontissa
router.post('/api/upload', (req, res, next) => {
  const form = formidable();
  console.log(req); // logataan pyyntö konsoliin
  form.parse(req); // parsitaan formi
  /* fileBegin -event suoritetaan kun tiedosto havaitaan upload streamissa.
  Eventin suoritus lataa kuvan palvelimen public/images kansioon */
  form.on('fileBegin', function (name, file) {
    file.path = path.join(__dirname, '../public/images/' + file.name);
    if (req.headers.origin === 'http://localhost:4200') { //jos kuva on tullut Angularista
      res.json({ status: 'done' }); // viesti onnistumisesta Angularille
    } else { // muuten vain näytetään kuva
      res.render('show', { filu: file.name });
    }
  });
});

// Reitti gallery -sivulle
// Kuvat laitetaan taulukkoon, joka välitetään gallery-sivulle
router.get('/gallery', (req, res) => {
  // polku images-kansioon
  const imgpath = path.join(__dirname, '../public/images');
  //console.log(imgpath);
  fs.readdir(imgpath, (error, files) => {
    //console.log(files);
    const imgarr = [];
    files.forEach((file) => {
      const image = '/images/' + file;
      imgarr.push(image);
      //console.log(imgarr);
    });
    res.render('gallery.ejs', { imgarr: imgarr });
  });
});

module.exports = router;
